MachineNONE     equ     0
MachineIntel    equ     1
MachineVLSI     equ     2
MachineRCC      equ     4
Machine450KX    equ     9
;-----------------------------------
PCIsetAX        PROC    near
                xchg    ax,dx
                mov     ax,8000h
                shl     eax,16
                xchg    ax,dx
                mov     dx,0CF8h
                out     dx,eax
                mov     dx,0CFCh
                in      eax,dx
                ret
PCIsetAX        ENDP

;--------------------------------------------------------
;       PCI_Check
;--------------------------------------------------------
PCI_Check       PROC    near
                cld
                xor     dx,dx
ifdef   PCIROM
                mov     ax,0B101h       ; Get PCI BIOS status
                int     1Ah             ; PCI BIOS call
                jc      PCI_Check_fail
                cmp     dx,20494350h    ; ?dx=='PCI '
                jnz     PCI_Check_fail
endif
IFDEF   ST20L16
                mov     ax,0A000h       ; Device No.20 , PC-9821St 
                call    PCIsetAX
                cmp     eax,84C58086h   ; Device ID of 450KX host bridge
                jne     @f
                mov     MachineType,Machine450KX
                jmp     PCI_Check_OK
        @@:
ENDIF
                xor     ax,ax
                call    PCIsetAX
                cmp     ax,8086h       ; Intel chipset
                jne     @f
                mov     MachineType,MachineIntel
                jmp     PCI_Check_OK
        @@:
                cmp     ax,1004h       ; VLSI_ChipSet
                jne     @f
                mov     MachineType,MachineVLSI
                jmp     PCI_Check_OK
        @@:
                cmp     eax,00051166h   ; RCCNEC
                jne     @f
                mov     MachineType,MachineRCC
                jmp     PCI_Check_fail  ; Ή <----! PCI_Check_OK
        @@:
                cmp     eax,0FFFFFFFFh ; non PCI chipset
                jne     @f
                mov     MachineType,MachineNONE
                jmp     PCI_Check_fail
        @@:     
PCI_Check_fail: 
                STC     ; Error Return 
                RET
PCI_Check_OK:   
                CLC
                RET
PCI_Check       ENDP

;-----------------------------------
D800_RAM        PROC   near     ; D800:016KB RAM ɂ
                cmp     MachineType,MachineIntel
                je      D800_RAM_intel
                cmp     MachineType,MachineVLSI
                je      D800_RAM_VLSI
                cmp     MachineType,Machine450KX
                je      D800_RAM_st20
                stc
                ret
D800_RAM_st20:  
                mov     ax,0C85Ch
                call    PCIsetAX          ; reg 5Dh
                and     ah,11111100b
                out     dx,eax
                mov     ax,0A05Ch
                jmp     D8_RAM_common
D800_RAM_intel:
                mov     ax,005Ch
D8_RAM_common:  call    PCIsetAX
                or      ah,00000011b    ; Write enabled 
                out     dx,eax
                clc
                ret
D800_RAM_VLSI:  
                mov     eax,80000064h
                mov     dx,0CF8h
                out     dx,eax
                mov     dx,0CFEh
                in      ax,dx
                or      ah,30h
                out     dx,ax
                clc
                ret
D800_RAM        ENDP
;-----------------------------------
D800_ROM        PROC   near     ; D800:016KB PCI-ROM ɂ
                cmp     MachineType,MachineIntel
                je      D800_ROM_intel
                cmp     MachineType,MachineVLSI
                je      D800_ROM_VLSI
ifdef   ST20L16
                mov     eax,8000A05Ch
                cmp     MachineType,Machine450KX
                je      D800_ROM_st20
endif
                stc
                ret
ifdef   ST20L16
D800_ROM_st20:  
                mov     ax,0C05Ch
                call    PCIsetAX
                and     ah,11111100b
                or      ah,00000001b ; reg 5Dh = PCIROM
                out     dx,eax
                mov     ax,0A05Ch
                jmp     D8_ROM_common
endif
D800_ROM_intel:
                mov     ax,005Ch
D8_ROM_common:  call    PCIsetAX
                and     ah,11111100b    ; PCI enabled 
                out     dx,eax
                clc
                ret
D800_ROM_VLSI:  
                mov     eax,80000064h
                mov     dx,0CF8h
                out     dx,eax
                mov     dx,0CFEh
                in      ax,dx
                and     ah,0CFh
                out     dx,ax
                clc
                ret
D800_ROM        ENDP
;-----------------------------------
D800_WP         PROC   near     ; D800:016KB ݋֎~ RAM ɂ
                cmp     MachineType,MachineIntel
                je      D800_WP_intel
                cmp     MachineType,MachineVLSI
                je      D800_WP_VLSI
                cmp     MachineType,Machine450KX
                je      D800_WP_st20
                stc
                ret
D800_WP_st20:   
                mov     ax,0C85Ch
                call    PCIsetAX
                and     ah,11111101b
                or      ah,00000010b
                out     dx,eax
                mov     ax,0A05Ch
                jmp     D8_WP_common
D800_WP_intel:
                mov     ax,005Ch
D8_WP_common:   call    PCIsetAX
                and     ah,11111100b
                or      ah,00000001b
                out     dx,eax
                ret
D800_WP_VLSI:  
                mov     eax,80000064h   ;(67h)
                mov     dx,0CF8h
                out     dx,eax
                mov     dx,0CFEh
                in      ax,dx
                and     ah,0CFh
                or      ah, 20h      ; RAM enabled(each nibbles bit 1=1),WP
                out     dx,ax
                ret
D800_WP         ENDP
;-----------------------------------
